Unit AER15R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AER15R(NM :Integer; N :Integer; var D :Array of Real;
                var E :Array of Real; var Z :Array of Real;
                var IERR :Integer);

implementation

procedure AER15R(NM :Integer; N :Integer; var D :Array of Real;
                var E :Array of Real; var Z :Array of Real;
                var IERR :Integer);
var
I,J,K,L,M,II,L1,MML :Integer;
B,C,F,G,H,P,R,S,MACHEP :Real;
const
SYS051 :Real = 1.192093E-07;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16;
begin
MACHEP := SYS051;
IERR := 0;
if ( N = 1 ) 
 then goto _16;
for I:=2 to N do
 begin
_1:
  E[I-2] := E[I-1];
 end;
F := 0.0;
B := 0.0;
E[N-1] := 0.0;
for L:=1 to N do
 begin
  J := 0;
  H := MACHEP*(Abs(D[L-1])+Abs(E[L-1]));
  if ( B < H ) 
   then B := H;
{  ********** }
  for M:=L to N do
   begin
    if ( Abs(E[M-1]) <= B ) 
     then goto _3;
{  ********** }
_2:
   end;
_3:
  if ( M = L ) 
   then goto _10;
_4:
  if ( J = 30 ) 
   then goto _15;
  J := J+1;
{  ********** }
  L1 := L+1;
  G := D[L-1];
  P := (D[L1-1]-G)/(2.0*E[L-1]);
  if ( Abs(P) > 1.0 ) 
   then R := Abs(P)*Sqrt(1.0+IntPower(1/P,2));
  if ( Abs(P) <= 1.0 ) 
   then R := Sqrt(P*P+1.0);
  D[L-1] := E[L-1]/(P+Sign(R,P));
  H := G-D[L-1];
  for I:=L1 to N do
   begin
_5:
    D[I-1] := D[I-1]-H;
   end;
  F := F+H;
{  ********** }
  P := D[M-1];
  C := 1.0;
  S := 0.0;
  MML := M-L;
{  ********** }
  for II:=1 to MML do
   begin
    I := M-II;
    G := C*E[I-1];
    H := C*P;
    if ( Abs(P) < Abs(E[I-1]) ) 
     then goto _6;
    C := E[I-1]/P;
    R := Sqrt(C*C+1.0);
    E[I+0] := S*P*R;
    S := C/R;
    C := 1.0/R;
    goto _7;
_6:
    C := P/E[I-1];
    R := Sqrt(C*C+1.0);
    E[I+0] := S*E[I-1]*R;
    S := 1.0/R;
    C := C*S;
_7:
    P := C*D[I-1]-S*G;
    D[I+0] := H+S*(C*G+S*D[I-1]);
{  ********** }
    for K:=1 to N do
     begin
      H := Z[(K-1)+(I+0)*NM];
      Z[(K-1)+(I+0)*NM] := S*Z[(K-1)+(I-1)*NM]+C*H;
      Z[(K-1)+(I-1)*NM] := C*Z[(K-1)+(I-1)*NM]-S*H;
_8:
     end;
_9:
   end;
  E[L-1] := S*P;
  D[L-1] := C*P;
  if ( Abs(E[L-1]) > B ) 
   then goto _4;
_10:
  D[L-1] := D[L-1]+F;
_11:
 end;
{  ********** }
for II:=2 to N do
 begin
  I := II-1;
  K := I;
  P := D[I-1];
  for J:=II to N do
   begin
    if ( D[J-1] >= P ) 
     then goto _12;
    K := J;
    P := D[J-1];
_12:
   end;
  if ( K = I ) 
   then goto _14;
  D[K-1] := D[I-1];
  D[I-1] := P;
  for J:=1 to N do
   begin
    P := Z[(J-1)+(I-1)*NM];
    Z[(J-1)+(I-1)*NM] := Z[(J-1)+(K-1)*NM];
    Z[(J-1)+(K-1)*NM] := P;
_13:
   end;
_14:
 end;
goto _16;
{  ********** }
_15:
IERR := L;
_16:
end;

end.
